/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxCiudad;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCatalogoDeParadas;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaCatalogoDeParadaController")
@Scope("prototype")
public class BusquedaCatalogoDeParadaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Parada> plwParada;
    private MyListbox paradaList;
    private Paging pagingParada;
    private Textbox txtNombre;
    private Textbox txtCVE;
    private MyComboboxCiudad cmbCiudad;

    public Paging getPagingParada() {
        return pagingParada;
    }

    public void setPagingParada(Paging pagingParada) {
        this.pagingParada = pagingParada;
    }

    public MyListbox getParadaList() {
        return paradaList;
    }

    public void setParadaList(MyListbox paradaList) {
        this.paradaList = paradaList;
    }

    public PagedListWrapper<Parada> getPlwParada() {
        return plwParada;
    }

    public void setPlwParada(PagedListWrapper<Parada> plwParada) {
        this.plwParada = plwParada;
    }

    public Textbox getTxtCVE() {
        return txtCVE;
    }

    public void setTxtCVE(Textbox txtCVE) {
        this.txtCVE = txtCVE;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new Parada());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        paradaList.setItemRenderer(new RenderCatalogoDeParadas());
        paradaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Parada c = (Parada) paradaList.getSelected();
                verPeriodo(c);
            }
        });

        txtNombre.focus();
        refreshLista();
    }

    private void verPeriodo(Parada c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("parada", c);
        args.put("paradaList", paradaList);

        openWindow("/gui/esquema_operacional/editarParada.zul",Labels.getLabel("editarCatalogoDeParadaController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Parada> parada =new HibernateSearchObject<Parada>(Parada.class, pagingParada.getPageSize());

        if(cmbCiudad.getValue() != null && !cmbCiudad.getValue().isEmpty()) {
        	parada.addFilterEqual("ciudad", cmbCiudad.getSelectedItem().getValue());
        }
        
        parada.addFilterLike("descparada", "%" + txtNombre.getText().trim().concat("%"));
        parada.addFilterLike("cveparada", "%" + txtCVE.getText().trim().concat("%"));

        parada.addFilterEqual("activo", Boolean.TRUE);

        parada.addFilterNotEqual("paradaId", -1);

        parada.addSortAsc("descparada");

        plwParada.init(parada, paradaList, pagingParada);

        if (paradaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),Labels.getLabel("busquedaCatalogoDeParadaController.window.title"),Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

	public MyComboboxCiudad getCmbCiudad() {
		return cmbCiudad;
	}

	public void setCmbCiudad(MyComboboxCiudad cmbCiudad) {
		this.cmbCiudad = cmbCiudad;
	}
}